<!DOCTYPE html>
<html lang="zxx">

<style>
@import url('https://fonts.googleapis.com/css?family=Cormorant+Garamond&display=swap');
</style>

<head>
  <meta charset="utf-8">
  <title>alessioboggeroMDEF</title>
  <!-- mobile responsive meta -->
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1">
  <!-- ** Plugins Needed for the Project ** -->
  <!-- Bootstrap -->
  <link rel="stylesheet" href="plugins/bootstrap/bootstrap.min.css">
  <!-- Main Stylesheet -->
  <link href="css/styleread.css" rel="stylesheet">
</head>


<body>

<a class="home" href="fab.html"><h5>fabacademy</h5></a>

<br><br>

<h5>

  For our input devices week I decided to use the infamous DHT11 temperature and humidity sensor.
  <br>
I often ferment food and drinks at home, so I thought it would be interesting to use it in order to keep track of the environment temperature and see if it is inside the right range.
<br><br>
DHT11 is a very cheap temperature and humidity digital sensor, but still pretty reliable.
<br>It works between 3V and 5.5V and has a pretty good range of measure: 0-90% for relative humidity and 0-50 C° for temperature.
<br>It also shows a pretty good resolution, around 1% for humidity and 0.1 °C for temperature.
<br><br>
<img class="fit" src="images/fab9/dht11.jpg" alt="blablabla">
<br><br>
My sensor is already mounted on a module that integrates the needed resistor for its functioning, so it will be even faster to setup.
<br><br>
Also, being it a diffused commercial sensor, we have to find libraries that allow its use.
<br>I installed the library provided by AdaFruit.
<br><br>
<img class="fit" src="images/fab9/library.png" alt="blablabla">
<br><br>
<br>After installing the right library, the code needed for you to run you sensor can be found inside of the examples of your IDE, making it very easy to use.
<br><br>
<img class="fit" src="images/fab9/example.png" alt="blablabla">
<br><br>
I connected everything on my breadboard.
<br><br>
<img class="fit" src="images/fab9/setup.jpg" alt="blablabla">
<br><br>
And then opened the example. The code is unified to be used with all the three sensors from the DHT family, so I simply had to define my sensor as the DHT11 model by uncommenting the right line.
<br><br>
<img class="fit" src="images/fab9/ide.png" alt="blablabla">
<br><br>
<img class="fit" src="images/fab9/define.png" alt="blablabla">
<br><br>
<img class="fit" src="images/fab9/define2.png" alt="blablabla">
<br><br>
Then I made sure the signal pin was the correct one.
<br><br>
The code worked fine as soon as I uploaded, also it prints an error when the sensor is disconnected.
<br><br>
<img class="fit" src="images/fab9/serial.png" alt="blablabla">
<br><br>
<p><a href="images/fab9/DHT_Unified_Sensor.ino" download>Here you can download the code file</a> <p>
<br>
<h5>
Since the idea is to use it as an interface to easily know if my fermentation temp is right, or if my dry-raging parameters are correct, I decided to add two LEDs, a blue one and a red one, to describe four possible states. So that it could become an independent object that does not need a monitor.
<br><br>
These are the signals I decided for the different states:
<br><br>
No LEDs on: temperature is fine
<br>Red ON: too hot for fermentation!
<br>Blue ON: too cold!
<br>Both ON: no temperature data
<br><br>

So what I did is basically add the two LEDs to the circuit through a 220 resistor each. Then I modified the code to have four conditions.
<br>If no data is read.
<br>If temperature is below 10 °C.
<br>If it is over 22°C.
<br>If nothing of these occur.
<br><br>
Since the blue led is on digital pin 10 and the red one is on digital pin 11, the functions will be:
<br><br>
No data read -> BOTH LEDs ON -> digitalWrite(10, HIGH); digitalWrite(11, HIGH);
<br>Temp under 10 -> BLUE LED ON ->  digitalWrite(10, HIGH); digitalWrite(11, LOW);
<br>Temp over 22 -> RED LED ON ->  digitalWrite(10, LOW); digitalWrite(11, HIGH);
<br>Everything fine -> NO LEDs ON -> digitalWrite(10, LOW); digitalWrite(11, LOW);
<br><br>
Here is a snap of part most of the code I wrote:
<br><br>
<img class="fit" src="images/fab9/code.png" alt="blablabla">
<br><br>
<p><a href="images/fab9/temptoled.ino" download>You can download it here</a> <p>

<h5>
Here you can see the final setup, with the red LED on since the temperature at the moment is a lot higher than 22 °C, I guess fermenting things in my house right now would be pretty dangerous.
<br><br>
<img class="fit" src="images/fab9/setup2.jpg" alt="blablabla">
